/**
*	http.c
*	HTTP
*	Copyright 2008 Junnichi Tomaru
*/
#include	"mailchecker.h"

const char 	index1[] = "HTTP/1.0 200 OK\r\nConnection: close\r\nContent-Type: text/html\r\n\r\n";
const char	index2[] = "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\" \"http://www.w3.org/TR/html4/loose.dtd\">\r\n<HTML>\r\n<HEAD>\r\n<TITLE>MAIL SETTING</TITLE>\r\n</HEAD>\r\n<BODY BGCOLOR=\"#FFFFFFFF\">\r\n<CENTER>MAIL HOST LIST<BR>\r\n<BR>\r\n<FORM ACTION=\"mail.cgi\" METHOD=\"POST\">\r\n<TABLE BORDER=\"1\">\r\n<TR ALIGN=\"CENTER\">\r\n<TH WIDTH=\"50\">No.</TH>\r\n<TH WIDTH=\"100\">POP3 SERVER NAME</TH>\r\n<TH WIDTH=\"100\">POP3 SERVER ADDRESS</TH>\r\n<TH WIDTH=\"50\">PORT</TH>\r\n<TH WIDTH=\"180\">USER ID</TH>\r\n<TH WIDTH=\"80\">PASSWORD</TH>\r\n<TH WIDTH=\"60\">CYCLE</TH>\r\n</TR>\r\n";
const char	index3[] = "<TR ALIGN=\"CENTER\">\r\n<TD>";
const char	index4[] = "</TD>\r\n<TD><INPUT TYPE=\"TEXT\" NAME=\"NAME";
const char	index5[] = "\" SIZE=\"19\" MAXLENGTH=\"7\" VALUE=\"";
const char	index6[] = "\"></TD>\r\n<TD><INPUT TYPE=\"TEXT\" NAME=\"HOST";
const char	index7[] = "\" SIZE=\"19\" MAXLENGTH=\"15\" VALUE=\"";
const char	index8[] = "\"></TD>\r\n<TD><INPUT TYPE=\"TEXT\" NAME=\"PORT";
const char	index9[] = "\" SIZE=\"7\" MAXLENGTH=\"5\" VALUE=\"";
const char	index10[] = "\"></TD>\r\n<TD><INPUT TYPE=\"TEXT\" NAME=\"USER";
const char	index11[] = "\" SIZE=\"32\" MAXLENGTH=\"30\" VALUE=\"";
const char	index12[] = "\"></TD>\r\n<TD><INPUT TYPE=\"TEXT\" NAME=\"PASS";
const char	index13[] = "\" SIZE=\"18\" MAXLENGTH=\"16\" VALUE=\"";
const char	index14[] = "\"></TD>\r\n<TD><INPUT TYPE=\"TEXT\" NAME=\"CYCL";
const char	index15[] = "\" SIZE=\"8\" MAXLENGTH=\"3\" VALUE=\"";
const char	index16[] = "\"></TD>\r\n</TR>\r\n";
const char	index17[] = "<TR ALIGN=\"CENTER\">\r\n<TD COLSPAN=\"4\">Firmware : ";
const char	index18[] = "</TD>\r\n<TD><INPUT TYPE=\"RESET\" VALUE=\"RESET\"></TD>\r\n<TD><INPUT TYPE=\"SUBMIT\" VALUE=\"SETTING\"></TD>\r\n</FORM>\r\n<TD COLSPAN=\"2\"><FORM ACTION=\"mail.cgi\" METHOD=\"GET\"><INPUT TYPE=\"HIDDEN\" NAME=\"BTN\" VALUE=\"RLD\"><INPUT TYPE=\"SUBMIT\" VALUE=\"RELOAD\"></FORM>\r\n</TD>\r\n</TR>\r\n</TABLE>\r\nNote:If Cycle = 0,Check Disabled.<BR>\r\n<ADDRESS>(c)Junnichi Tomaru</ADDRESS>\r\n</CENTER>\r\n</BODY>\r\n</HTML>";


/**
*	Weby[WTu[`
*	 in	`l
*	out	Ȃ
*/
void	index_sub( byte ch )
{
	char	buf[16];

	setsiostr( index3 );
	setsio1( ch + '1' );
	setsiostr( index4 );
	setsio1( ch + '1' );
	setsiostr( index5 );
	setsiostr( settei[ch].name );
	setsiostr( index6 );
	setsio1( ch + '1' );
	setsiostr( index7 );
	long2ipstr( settei[ch].ipaddr, buf );
	setsiostr( buf );
	setsiostr( index8 );
	setsio1( ch + '1' );
	setsiostr( index9 );
	setsiostr( utoa( settei[ch].port, buf ) );
	setsiostr( index10 );
	setsio1( ch + '1' );
	setsiostr( index11 );
	setsiostr( settei[ch].userid );
	setsiostr( index12 );
	setsio1( ch + '1' );
	setsiostr( index13 );
	setsiostr( settei[ch].password );
	setsiostr( index14 );
	setsio1( ch + '1' );
	setsiostr( index15 );
	setsiostr( utoa( settei[ch].cycle, buf ) );
	setsiostr( index16 );
}


/**
*	Weby[Wԑ
*	 in	Ȃ
*	out	Ȃ
*/
void	http_index( void )
{
	setsiostr( index1 );	/* Xe[^X */
	setsiostr( index2 );	/* wb_ */
	index_sub( 0 );
	index_sub( 1 );
	index_sub( 2 );
	setsiostr( index17 );
	setsiostr( VERSION );
	setsiostr( index18 );	/* tb^ */
}


/**
*	HTTP(GET)
*	 in	obt@(ŏ̂Ps)
*	out	Ȃ
*/
void	http_get( char *buf )
{
	char	*p, *q;

	p = buf + 5;
	q = strstr( buf, "HTTP/" );	/*  */
	if( q != NULL ){
		*q = '\0';
	}
	if(( *p == ' ' ) || ( strncmp( p, "mail.cgi?", 7 ) == 0 )){
		http_index( );
	}
	else{		/* Ӑ}Ȃv */
		disconnect( );
	}
}


/**
*	CGI
*	 in	Ȃ
*	out	Ȃ
*/
void	exec_cgi( void )
{
	char	buf[32];
	int	i;

	getsiostr( buf, 32, '&' );	/* zXg */
	strcpy( settei[0].name, buf + 6 );
	getsiostr( buf, 32, '&' );	/* zXgAhX */
	settei[0].ipaddr = ipstr2bin( buf + 6 );
	getsiostr( buf, 32, '&' );	/* |[gԍ */
	settei[0].port = atoi( buf + 6 );
	getsiostr( buf, 32, '&' );	/* ID */
	strcpy( settei[0].userid, buf + 6 );
	getsiostr( buf, 32, '&' );	/* PASSWORD */
	strcpy( settei[0].password, buf + 6 );
	getsiostr( buf, 32, '&' );	/* `FbNԊu */
	i = atoi( buf + 6 );
	if(( i == 0 ) || ( i >= 256 )){	/*  */
		settei[0].cycle = 0;
		settei[0].enable = off;
	}
	else{
		settei[0].cycle = (byte)i;
		settei[0].enable = on;
	}

	getsiostr( buf, 32, '&' );	/* zXg */
	strcpy( settei[1].name, buf + 6 );
	getsiostr( buf, 32, '&' );	/* zXgAhX */
	settei[1].ipaddr = ipstr2bin( buf + 6 );
	getsiostr( buf, 32, '&' );	/* |[gԍ */
	settei[1].port = atoi( buf + 6 );
	getsiostr( buf, 32, '&' );	/* ID */
	strcpy( settei[1].userid, buf + 6 );
	getsiostr( buf, 32, '&' );	/* PASSWORD */
	strcpy( settei[1].password, buf + 6 );
	getsiostr( buf, 32, '&' );	/* `FbNԊu */
	i = atoi( buf + 6 );
	if(( i == 0 ) || ( i >= 256 )){	/*  */
		settei[1].cycle = 0;
		settei[1].enable = off;
	}
	else{
		settei[1].cycle = (byte)i;
		settei[1].enable = on;
	}

	getsiostr( buf, 32, '&' );	/* zXg */
	strcpy( settei[2].name, buf + 6 );
	getsiostr( buf, 32, '&' );	/* zXgAhX */
	settei[2].ipaddr = ipstr2bin( buf + 6 );
	getsiostr( buf, 32, '&' );	/* |[gԍ */
	settei[2].port = atoi( buf + 6 );
	getsiostr( buf, 32, '&' );	/* ID */
	strcpy( settei[2].userid, buf + 6 );
	getsiostr( buf, 32, '&' );	/* PASSWORD */
	strcpy( settei[2].password, buf + 6 );
	getsiostr( buf, 32, '\r' );	/* `FbNԊu */
	i = atoi( buf + 6 );
	if(( i == 0 ) || ( i >= 256 )){	/*  */
		settei[2].cycle = 0;
		settei[2].enable = off;
	}
	else{
		settei[2].cycle = (byte)i;
		settei[2].enable = on;
	}
}


/**
*	HTTP(POST)
*	 in	f[^obt@
*	out	Ȃ
*/
void	http_post( char *buf )
{
	char	*p, cnt, f;
	byte	c;
	word	wt;
	int	adr, sadr;

	p = buf + 6;
	if(( *p == ' ' ) || ( strncmp( p, "mail.cgi", 8 ) == 0 )){
		f = 0;
		wt = getcount1ms( );
		for( cnt = c = 0; f == 0; ){	/* CRLF݂̂̍s */
			c = getsio1( );
			if( c != 0xff ){
				if(( c == '\r' ) && ( cnt == 0 )){/* 擪CR */
					f = 1;
				}
				else if( c == '\n' ){	/* sŌ */
					cnt = 0;
				}
				else{
					cnt++;
				}
			}
			else if(( getcount1ms( ) - wt ) >= 5000U ){	/* ^CAEg */
				break;
			}
		}
		if( f == 1 ){	/* L */
			exec_cgi( );
			get_settei( &sadr, &adr );
			erase_eeprom( sadr );	/* ÕubN */
			buf[0] = 1;	/* tÔ */
			write_eeprom( adr, buf, 1 );
			write_eeprom( adr + 1, (char *)&settei, sizeof( settei ));
		}
		http_index( );
	}
	else{		/* Ӑ}Ȃv */
		disconnect( );
	}
}


/* end of http.c */
