/**
*	mailchecker.h
*	WiPORT[`FbJ	Cwb_
*	2008.09.11	Junnichi Tomaru
*/
#include	<stdlib.h>
#include	<string.h>
#include	<ctype.h>
#include	"r8c29.h"
#include	"define.h"
#include	"lcd.h"
#include	"ut.h"
#include	"userdef.h"

#define	VERSION	"version 1.00.02.00"

struct SETTEI_T{	/* ݒ 64byte */
	char	name[8];	/* T[o */
	dword	ipaddr;		/* IPAhX */
	word	port;		/* POP3T[o|[g */
	char	userid[32];	/* [UID */
	char	password[16];	/* pX[h */
	byte	cycle;		/* `FbN */
	swbool	enable;		/* L */
};

struct STATUS_T{	/* [Xe[^X 7byte */
	word	sec;		/* `FbNpb */
	int	mailcnt;	/* [ */
	swbool	mailchk;	/* `FbNtO */
	char	mailerr;	/* G[Xe[^X */
	swbool	mailsts;	/* [Xe[^X */
};

/* O[oϐ(荞݂łg)  */
_Extern word	counter;	/* 1msJE^ */
_Extern byte	second;
_Extern word	minute;
_Extern char	rx1buf[256];
_Extern byte	rx1hp, rx1tp, rx1ct;
_Extern char	keybuf[4];
_Extern char	keypnt;

/* ̑ */
_Extern char	ipaddr[32];
_Extern struct SETTEI_T	settei[3];	/* [ݒ 192byte */
_Extern struct STATUS_T	status[3];	/*  */
_Extern char	mode;		/* 샂[h */
_Extern swbool	init;		/* ŏ̃`FbN */
_Extern word	ledt;
_Extern char	domain[9][22];	/* [AhX */

/* bios.c */
char	getsio1( void );
void	setsio1( char data );
char	waitreceive( void );
void	clrsio( void );
byte	getsiocount( void );
char	getsiostr( char *buf, byte cnt, char dl );
void	setsiostr( char *buf );
word	getcount1ms( void );
void	waitms( word ms );
word	gettimer( void );
char	keysense( void );
char	keyinput( void );
bool	erase_eeprom( int addr );
char	get_settei( int *eadr, int *wadr );
void	read_eeprom( int addr, char *data, int cnt );
bool	write_eeprom( int addr, char *data, int cnt );

/* display.c */
void	prodisp( char y, char pnt );
void	display_addr( char sel );
void	redraw( char sel );

/* pop3.c */
swbool	pop_status( char *buf );
char	pop_connect( dword addr, int port );
char	pop_ninsyou( char ch );
int	pop_mailcnt( void );
char	pop_quit( void );

/* http.c */
void	http_get( char *buf );
void	http_post( char *buf );

/* wiport.c */
void	send_command( char *buf );
char	getresponse( char *buf, byte cnt );
char	wait_nocarrier( void );
char	disconnect( void );

/* mailchecker.c */
void	mail_led( void );

/* end of mailchecker.h */
